#include <stdio.h>
#include <stdlib.h>

#include <Windows.h>

#include "../CTimeTag/Include/CTimeTag.h"
#include "../CTimeTag/Include/CLogic.h"
#ifdef FAT_EXE
#include <chrono>
#include "../CTimeTagSource/CTest.h" 
#include "../CTimeTagSource/CUSB.h"
#endif

using namespace TimeTag;
void breakpoint()
{
	int x = 0;
}
void ReadTest(CTimeTag &timetag)
{
	printf ("simple read test...\n");
		timetag.StartTimetags();
		unsigned char *chan;
		long long *time;

		for (int i= 0; i<1000; i++)
		{
			unsigned char channel;
			long long time;
			if (timetag.ReadNextTag(channel, time))
				printf ("Channel %d time %lld", channel, time);
			else
				Sleep(1);
		}
	
		int count= timetag.ReadTags(chan, time);
		printf ("count %d\n", count);
		if (count > 50)
			count = 50;
		long long old= 0;
	
		
		double resNs= timetag.GetResolution()*1e9;
		
		for (int j= 0; j<count; j++)
		{
			int diff= (int)(time[j]-old);
			double diffNs= diff* resNs;
			printf ("chan %d time %d diff %d = %f ns\n", (int)chan[j], (int)time[j], diff, diffNs);
			old= time[j];
		}

		timetag.StopTimetags();


}
/*
void LogicTest(CTimeTag &timetag)
{
	printf ("Logic test \n");
	for (int i= 0; i<16; i++)
	{
		timetag.GetHelper()->
	}
}*/

void TomTest(CTimeTag &timetag)
{
	//LogicTest(timetag);
	printf ("Tom Special Test\n");
	
	
	ChannelType *chan;
	TimeType *time;
	double res= timetag.GetResolution();
	

for(int test= 0;;test++)
	{
	timetag.StartTimetags();	
	double  min= 1E9;
	double max= -1E9;
	printf ("\n");
	long long old= 0;
	int extra= 10;
	for (int i= 0;i<1000*extra;i++)
	{
		int count= timetag.ReadTags(chan, time);
		
		for (int j= 0; j<count; j++)
		{
			if (chan[j] == 30)
			{
				printf ("\nOverflow %lld\n", time[j]);
			}
			else
			{

			long long diff= time[j]-old;
			double dtime = diff* res;
			if (old == 0)
			{
				old= time[j];
				continue;
			}
			old= time[j];
			int x;
			if (diff <= 0)
			{
				printf ("\nErr !!! Flags= %llx, i= %d, j= %d" ,timetag.ReadErrorFlags(), i, j);
				printf ("diff= %lld",diff);
				printf ("= %llx",diff);
				printf ("= %f\n",diff*timetag.GetResolution());
				x= 8;
			}
			if (dtime < min)
				min= dtime;
			if (dtime > max)
				max = dtime;
			}

			
		}
		
		printf ("test %4d tags %8d min %10.4f us max %10.4f us    \r", test, count, min*1e6, max*1e6);
	}
	timetag.StopTimetags();
	long long flags= timetag.ReadErrorFlags();
	if (flags)
		printf ("\nFlag check= %llx", flags);
}

}

void SpeedTest(CTimeTag &timetag)
{
	printf ("Timetag Speed Test\n");
	printf ("Increase rate until error goes on\n\n");  

	timetag.StartTimetags();
	ChannelType *chan;
	TimeType *time;
	double res= timetag.GetResolution();
	long long old= 0;
	long long  min;
	long long max;
	int mask = 0xfffffff;
	mask = 0xf;  //m.2 Test
	long long starttime = 0;
	int totcount = 0;
/*
	timetag.ActivateTestSignal(mask);  //Internal Test Signals
	if (mask)
		printf("Test Mask %x\n", mask);
		*/
	for (int i= 0;;i++)
	{
		if (i %1024== 0)
		{
			long long err= timetag.ReadErrorFlags();
			if (err)
				printf (" err: %llx %s", err, timetag.GetErrorText(err).c_str());
			printf("\n");
			min= 1LL<<60;
		    max= 0;
		}
		int count= timetag.ReadTags(chan, time);

		
		for (int j= 0; j<count; j++)
		{


			if (chan[j] == 117)  //30 for old timetagger
				printf (" Overflow ");
			
			else
			{

			long long diff= time[j]-old;
			old= time[j];
			if (diff < min)
			{
				min = diff;
			}
			if (diff > max)
				max = diff;
			}
		
		}
		long long timediff = old - starttime;
		starttime = old;
		double rate = count / (timediff*res)/1e6;
		
		printf ("\rtags %8d min %10.4f ns max %10.4f ns  rate %3.2f MTags/s        ", count, min*res*1e9, max*res*1e9, rate);
	}
	timetag.StopTimetags();

}

void LogicTest(CTimeTag &timetag)
{
	printf ("Please note: Logic test ist only possible, when logic feature is enabled in device\n");
	CLogic logic(&timetag);
	logic.SwitchLogicMode();

	int delayTicks= (int)(66e-9/timetag.GetResolution());
	logic.SetDelay(1, delayTicks);
	logic.SetDelay(3, 0);

	logic.SetWindowWidth((int)(1e-9 /timetag.GetResolution()));

	printf ("\n");
	for (int i= 0; i<1000; i++)
	{
		logic.ReadLogic();	
		double time= logic.GetTimeCounter()*5e-9;
		double single1= logic.CalcCountPos(1)/time/1000;
		double single3= logic.CalcCountPos(4)/time/1000;
		double pattern= logic.CalcCountPos(5)/time/1000;



		printf ("\r s1: %8.3f s3:%8.3f both:%8.3f", single1, single3, pattern);

	}
	printf ("\nready\n");
	

}
void EnableGate(CTimeTag &timetag)
{

	int width= 34;
	printf ("Gate %d ns active !!!\n", width);	
	timetag.UseTimetagGate(1);
	timetag.SetGateWidth(width*32/5);
}

void Help()
{
	printf ("\n\nCommands\n");
	printf ("--------\n");
	printf ("H Help (this text)\n");
	printf ("C Calibrate\n");
	printf ("L LogicTest\n");
	printf ("S SpeedTest\n");
	printf("F Fast Save\n");
	printf ("R ReadTags\n");
	printf ("G Enable Gate\n");
	printf ("V VCU118 Hardware Streaming\n");
	printf ("Q Quit\n");

	printf ("\n");


}

void DoStreamingElegant(CTimeTag &timetag)
{
	printf("Hardware streaming Demo...\n");
	timetag.StartStreaming();
	
	double resolution = timetag.GetResolution();
	int time_ms= 10;
	
	double maxRate = 950 * 10e6;
	for (int i= 0; i<5000; i= i+1)
	{
		
		timetag.StartTimetags();
		Sleep(time_ms);
		//Sleep(100);
		printf("----------------\n");
		unsigned char channel;
		long long startTime;
		
		int t;
		for ( t = 0; t < 50; t++)
		{
			if (timetag.ReadNextTag(channel, startTime))
			{
				break;
			}
			Sleep(1);
			


		}

		printf("t= %d\n", t);
//		getchar( );


		if (timetag.ReadNextTag(channel, startTime))

			
		{
			printf("first channel %d, first time %3.2f ", channel, startTime*resolution);
			int i;
			int timeout = (int)(time_ms/1000.0*maxRate);
			long long  limit = (long long)(startTime + time_ms / resolution / 1000.0);
			for (i= 0; i<timeout; i++)
			{
				long long time;
				if (!timetag.ReadNextTag(channel, time))
				{
					printf("No data after %d???\n", i);
					break;
				}
				if (time > limit)
				{
					printf("last channel %d, diff %lld= %f ms\n", channel,  (time-startTime), (time - startTime)*resolution*1000.0);
					break;
				}
			
			}
			if (i == timeout)
				printf("timeout !!\n");
		}
		else
		{
			printf("nothing here?\n");
		}
		timetag.StopTimetags();



		Sleep(1000- time_ms);
		

	}
	timetag.StopStreaming();
	

}


void ActivateTestSignal(CTimeTag &timetag)
{
	long long mask = 0x7ffffffffffffff;
	int count = timetag.ActivateTestSignal(mask, 0);  //Internal Test Signals
	if (mask)
		printf("Test Mask %llx %d MHz\n", mask, count * 16);
}

void DoFastSave(CTimeTag &timetag)
{
	char * filename = "test.tt";
	printf("Press enter to start saving to file %s\n", filename);
	getchar();
	timetag.StartSavingFast(filename);
	
	printf("Press enter to stop saving\n");
	getchar();
	timetag.StopSaving();

}
int PrintUsage()
{
	printf("usage: CppDemo replay filename\n");
	printf("allowed endings are .tt and .tt16");
	return 1;
}
int TxTest(int argc, char **argv);

#ifdef FAT_EXE
int TxTest(int argc, char **argv)
{
	if (argc != 3)
	
		return PrintUsage();
	if (strcmp (argv[1], "replay"))
		return PrintUsage();



	char * filename = argv[2];


	//filename = "r:\\tags.tt";
	//filename = "r:\\tags.tt16";
	//filename = "r:\\tdm800-512.tt";
	//filename = "r:\\tdm800-1024.tt16";
	// filename = "r:\\g6-512.tt";
	


	printf("Filename = %s\n", filename);

	bool compact;
	if (strstr(filename, ".tt16"))
		compact = true;
	else if (strstr(filename, ".tt"))
		compact = false;
	else
		return PrintUsage();

	//TODO: support compact?
	printf("Compact Format = %s\n", compact ? "true" : "false");
	//Receiver r;

	Receiver * vcu = new Receiver();
	if (!vcu)
	{
		printf("Can't open receiver\n");
		return 2;
	}
	try
	{
		printf("Receiver is connfigured for %s\n", vcu->is6G() ? "TDM-6G" : "TDM-800/TDM1600");
		vcu->UseReplay(true);
		vcu->UseCompact(compact);
		
		vcu->StopTxDMA();
		printf("setup...\n");
		vcu->SetupTxDMA(filename);
		vcu->ResetAll();

		auto start = chrono::steady_clock::now();
		vcu->StartTxDMA();
		vcu->TransmitLoop();
		auto stop = chrono::steady_clock::now();
		int ms = chrono::duration_cast<chrono::milliseconds>(stop - start).count();
		printf("Elapsed time: %d ms\n", ms);

		vcu->UseReplay(false);

	}
	catch (std::exception &ex)
	{
		printf("Error: %s\n", ex.what());
	}
	delete vcu;
	//printf("Press enter\n");
	//getchar();
	return 0;
		
}
#else
int TxTest(int argc, char **argv)
{
	printf("Test not implemented in this version\n");
	return 1;
	}
#endif
void DoStreaming(CTimeTag &timetag)
{
	printf("Hardware streaming Demo...\n");
	timetag.StartStreaming();

	double resolution = timetag.GetResolution();
	int time_ms = 10;
	int diff10ms = (int)(10e-3 / resolution);

	
	//ActivateTestSignal(timetag);


	for (int t = 0; t < 60; t = t + 1)  //run for about 60 seconds
	{
		
		timetag.StartTimetags();
		Sleep(time_ms);

		int totcount = 0;
		long long startTime = -1;


		for (int i = 0; i < 50; i++)  //At high rates we have to read several times
		{
			unsigned char startChannel;
			long long endTime;
			unsigned char *channels;
			long long *times;

			int count = timetag.ReadTags(channels, times);
			if (count > 0) 
			{
				//Please be careful: You either have to process your data here or make a copy. It can be overwritten by the next ReadTags()
				totcount += count;
				if (startTime == -1)  //This is executed the fitst time we actually have got data
				{
					startTime = times[0];
					startChannel = channels[0];
				}
				endTime = times[count - 1];

				if (endTime - startTime > diff10ms)  //If we have got our 10 ms
				{
					long long  err = timetag.ReadErrorFlags();  //Monitoring the error flags is always a good idea
					std::string s = timetag.GetErrorText(err);
					printf("Start %3.3f diff %3.1f ms count %4dk loop %2d %s\n", startTime*resolution, (endTime - startTime)*resolution*1000, totcount/1000, i, s.c_str());
					break;
				}

			}
			else   //Sometimes ReadTags can return zero
			{
				Sleep(1);
				printf(".");
				continue;
			}
		}
		timetag.StopTimetags();
		Sleep(1000 - time_ms);
	
	}
	timetag.StopStreaming();


}



void Menue(CTimeTag &timetag)
{
	printf ("\n:");
	char c= getchar();
	switch (toupper(c))
	{
		case 'H': 
			Help(); 
			break;
		case 'C': 
			printf ("Calibrating.....\n");
			fflush(stdout);
			timetag.Calibrate();
			printf ("ok !\n");
			break;
		case 'L': 
			LogicTest(timetag);
			break;
		case 'S': 
			SpeedTest(timetag);
			break;
		case 'R': 
			ReadTest(timetag);
		
			break;
		case 'T': 
			TomTest(timetag);
			break;
		case 'G':
			EnableGate(timetag);
			break;
		case 'V':
			DoStreaming(timetag);
			break;
		case 'F':
			DoFastSave(timetag);
			break;

		case 'Q':
			timetag.Close();
			exit(0);
	}

}

void MenueLoop(CTimeTag &timetag)
{
	Help();
	for (;;)
	{
		
		try 
		{
			Menue(timetag);
		}
		catch (TimeTag::Exception ex)
		{
			printf ("\nErr: %s\n", ex.GetMessageText().c_str());
		}

		catch (std::exception ex)
		{
			printf ("\nErr: %s\n", ex.what());
		}

	}
}


void Stresstest()
{
		CTimeTag timetag; 

		//timetag.OpenUsb();
		timetag.OpenPCIe();
		printf ("Doing Stresstest\n");
		double value= 0;
		for (int count= 0; ;count++)
		{
			for (int i= 1; i<=64; i++)
				timetag.SetInputThreshold(i, value);
			printf ("count %d value = %f\n", count, value);
			value += 0.01;
			if (value>=2)
				value= -2;
		}


}
int main(int argc, char* argv[])
{ 

	if (argc > 1)
		return TxTest(argc, argv);  //Imternal Test, please ignore

	
	try
	{

		CTimeTag timetag;
		timetag.EnableMessages(true);
		timetag.OpenPCIe();
		//timetag.OpenUSB();
		for (int i= 1; i<=64; i++)
			timetag.SetInputThreshold(i, 0.5);

		MenueLoop(timetag);
	}

	catch (TimeTag::Exception ex)
	{
		printf ("\nErr: %s\n", ex.GetMessageText().c_str());
		printf ("Press enter\n");
		getchar();
	}

	catch(std::exception  &ex)
	{
		printf ("Unknown std::exception while opening device: %s\n", ex.what());
		printf ("Press enter\n");
		getchar();

	}

	catch(...)
	{
		printf ("Unknown exception while opening device!\n");
		printf ("Press enter\n");
		getchar();

	}


	

	return 0;
}

